/* ProgPLN : Windoo MSF03 */
#include <windows.h>
// AJOUT MSF03A
#define ID_FICQUITTER 9901
#define ID_FICRIEN 9902
// FIN AJOUT MSF03A

/*  Dclaration de notre fonction de rappel dfinie plus bas */
LRESULT CALLBACK FoncRapp(HWND, UINT, WPARAM, LPARAM);

/*  Variable globale pour le nom de la classe */
char szWinClasse[ ] = "ProgPLN"; // Nom de la Winclasse

/* ETAPE 1 : Corps de la fonction principale WinMain */
int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nCmdShow)
{
    HWND hfen;               /* Identifiant (handle) de la fentre */
    MSG messages;            /* Rservoir de stockage des messages pour l'application */
    WNDCLASSEX wincl;        /* Structure de donnes de la Winclasse */

    /* Structure constitutive de la fentre */
    wincl.cbSize = sizeof(WNDCLASSEX);
    wincl.style  = CS_DBLCLKS;          /* Style de Winclasse */
    wincl.lpfnWndProc   = FoncRapp;     /* Fonction de rappel pour le systme */
    wincl.hInstance     = hThisInstance;
    wincl.lpszClassName = szWinClasse;

    wincl.lpszMenuName = NULL;                 /* Nom d'une ressource menu */
    wincl.hIcon   = LoadIcon(NULL, IDI_APPLICATION); /* Choix icne */
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION); /* Choix pointeur souris */
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;     /* Couleur du fond de la fentre */
    wincl.cbClsExtra    = 0;                    /* Pas de donnes bonus pour la classe */
    wincl.cbWndExtra    = 0;                    /* ni pour l'instance */


    /* Inscription de la classe de la fentre (register) */
    if (!RegisterClassEx(&wincl)) // Renvoie 0 si chec, donc on quitte
        return 0;

    /* ETAPE 2 : Cration de la fentre principale (toujours dans WinMain()) */
    hfen = CreateWindowEx (
           0,                   /* Modalits spcifiques */
           szWinClasse,         /* Nom de la Winclasse (voir L38) */
           "MSF03 : Essai MS-Windows avec menu",       /* Barre de titre */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Le systme Windows dcide o placer */
           CW_USEDEFAULT,       /* la fentre  l'ouverture */
           640,                 /* Largeur de fentre */
           480,                 /* Hauteur de fentre */
           HWND_DESKTOP,        /* Fentre principale donc fille du bureau */
           NULL,                /* Pas encore de menu */
           hThisInstance,       /* Gestionnaire de l'instance */
           NULL                 /* Pas de donnes de cration */
           );

    ShowWindow(hfen, nCmdShow); /* Rendu visuel de la fentre prpare */

    /* ETAPE 3 : boucle de messages. On n'en sort que si GetMessage() renvoie 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages); /* Traduction codes clavier */
        DispatchMessage(&messages);  /* Envoi de message  FoncRapp */
    }

    return messages.wParam; /* Quitte si 0 (valeur fournie par PostQuitMessage()) */
}

/*  ETAPE 4 : Fonction de rappel que le systme va appeler via la fonction DispatchMessage()  */
LRESULT CALLBACK FoncRapp (HWND hfen, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* Analyse des messages d'vnements */
    {
// AJOUT 02 NOTEZ LES ACCOLADES QUI DEVIENNENT OBLIGATOIRES SI DECLA VAR
    case WM_RBUTTONDOWN:
      {
      char szNomFicEXE[MAX_PATH];
      HINSTANCE hInstance = GetModuleHandle(NULL);
      GetModuleFileName(hInstance, szNomFicEXE, MAX_PATH);
      MessageBox(hfen, szNomFicEXE, "Je suis la version vivante de ce fichier excutable :", MB_OK | MB_ICONINFORMATION);
      }
      break;
// FIN AJOUT 02
    case WM_DESTROY:
      PostQuitMessage (0);      /* Injection d'un message WM_QUIT pour quitter l'appli */
      break;
// AJOUT MSF03B
    case WM_CREATE:
    {
      HMENU hMenu, hSubMenu;
      HICON hIcon, hIconSm;
      hMenu = CreateMenu();
      hSubMenu = CreatePopupMenu();
      AppendMenu(hSubMenu, MF_STRING, ID_FICRIEN, "&Rien du tout");
      AppendMenu(hSubMenu, MF_STRING, ID_FICQUITTER, "&Quitter");
      AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&Fichier");
      SetMenu(hfen, hMenu);
      hIcon = (HICON)LoadImage(NULL, "MSFicone.ico", IMAGE_ICON, 32, 32, LR_LOADFROMFILE);
      if(hIcon) SendMessage(hfen, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
      else      MessageBox(hfen, "Fichier .ico introuvable !", "Erreur", MB_OK | MB_ICONERROR);
    }
      break;
    case WM_COMMAND:
      switch(LOWORD(wParam))
      {
        case ID_FICQUITTER:
          PostMessage(hfen, WM_CLOSE, 0, 0);
          break;
        case ID_FICRIEN:
          MessageBox(hfen, "Commande Rien du tout", "Raction normale", MB_OK);
          break;
      }
      break;
// FIN AJOUT MSF03B
      default:                      /* On rend le contrle pour tous les autres messages */
        return DefWindowProc(hfen, message, wParam, lParam);
    }
  return 0;
}
