/* ProgPLN : Windoo MSF04 */
#include <windows.h>
#include <stdio.h>

/*  Prototype de notre fonction de rappel dfinie plus bas */
LRESULT CALLBACK FoncRapp(HWND, UINT, WPARAM, LPARAM);

/*  Variable globale pour le nom de la classe */
char szWinClasse[ ] = "ProgPLN"; // Nom de la Winclasse

/* ETAPE 1 : Corps de la fonction principale WinMain */
int WINAPI WinMain (HINSTANCE hMonInsta,
                    HINSTANCE hInstaPrec,
                    LPSTR lpszArgument,
                    int nCmdShow)
{
    HWND hfen;             /* Identifiant (handle) de la fentre */
    MSG messages;          /* Rservoir de stockage des messages pour l'application */
    WNDCLASSEX wincl;      /* Structure de donnes de la Winclasse */
    /* Structure constitutive de la fentre */
    wincl.cbSize = sizeof(WNDCLASSEX);
    wincl.style  = CS_DBLCLKS;          /* Style de Winclasse */
    wincl.lpfnWndProc   = FoncRapp;     /* Fonction de rappel pour le systme */
    wincl.hInstance     = hMonInsta;
    wincl.lpszClassName = szWinClasse;

    wincl.lpszMenuName = NULL;                 /* Nom d'une ressource menu */
    wincl.hIcon   = LoadIcon(NULL, IDI_APPLICATION); /* Choix icne */
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION); /* Choix pointeur souris */
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND; /* Couleur du fond de fentre */
    wincl.cbClsExtra    = 0;                /* Pas de donnes bonus pour la classe */
    wincl.cbWndExtra    = 0;                /* ni pour l'instance */

    /* Inscription de la classe de la fentre (register) */
    if (!RegisterClassEx(&wincl))  return 0; // Renvoie 0 si chec, donc on quitte

/* ETAPE 2 : Cration de la fentre principale (toujours dans WinMain()) */
    hfen = CreateWindowEx (
           0,                   /* Modalits spcifiques */
           szWinClasse,         /* Nom de la Winclasse (voir L9) */
           "Exploration des coordonnes (MSF04)",       /* Barre de titre */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Le systme Windows dcide o placer */
           CW_USEDEFAULT,       /* la fentre  l'ouverture */
           450, 250,            /* Largeur et hauteur de fentre */
           HWND_DESKTOP,        /* Fentre principale donc fille du bureau */
           NULL,                /* Pas encore de menu */
           hMonInsta,           /* Gestionnaire de l'instance */
           NULL                 /* Pas de donnes de cration */
           );

    ShowWindow(hfen, nCmdShow); /* Rendu visuel de la fentre prpare */

/* ETAPE 3 : Boucle de messages. On n'en sort que si GetMessage() renvoie 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages); /* Traduction codes clavier */
        DispatchMessage(&messages);  /* Envoi de message  FoncRapp */
    }

    return messages.wParam; /* Quitte si 0 (valeur fournie par PostQuitMessage()) */
}

/*  ETAPE 4 : Fonction de rappel que le systme va appeler via DispatchMessage()  */
LRESULT CALLBACK FoncRapp (HWND hfen, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;  	     // Device Context
	char chPub[] = "Programmer pour les nuls et la programmation par vnements !";
	char tamp[80]; // Pour afficher du texte
// Analyse des messages d'vnements
    switch (message)
    {
// SI Bouton Droit sollicit
      case WM_RBUTTONDOWN:
        MessageBox(hfen, chPub, "Un MessageBox", MB_OK | MB_ICONINFORMATION);
        break;
// Si Quitter demand
      case WM_DESTROY: /* Injection d'un message WM_QUIT pour quitter l'appli */
        PostQuitMessage (0);
        break;
// SI Fentre dplace
      case WM_MOVE: {
        int win_x = LOWORD(lParam); // Position de la fentre
        int win_y = HIWORD(lParam);
        hDC = GetDC(hfen);       // Prendre un DC (contexte graphique)
        sprintf(tamp,"%d, %d (fentre)      *", win_x, win_y);
        TextOut(hDC, 0, 0, tamp, strlen(tamp));
        sprintf(tamp," WM_MOVE : Coordonnes cran : (%d, %d)  ", win_x, win_y);
        TextOut(hDC, 0, 80, tamp, strlen(tamp));
        ReleaseDC(hfen, hDC);    // Rendre le DC !
      } break;
// SI Pointeur dplac
      case WM_MOUSEMOVE: {
        int souriX = (int)LOWORD(lParam); // Position du pointeur
        int souriY = (int)HIWORD(lParam);
        int boutons = (int)wParam;         // Statut des 3 boutons
        hDC = GetDC(hfen);       // Prendre un DC
        sprintf(tamp,"%d, %d (souris)   ", souriX, souriY);
        TextOut(hDC, 0, 20, tamp, strlen(tamp));
        sprintf(tamp," WM_MOUSEMOVE : Pointeur souris : (%d,%d)   ", souriX,souriY);
        TextOut(hDC, 0, 100, tamp, strlen(tamp));
        sprintf(tamp," Bouton CENTRAL = %d ", ((boutons & MK_MBUTTON) ? 1 : 0));
        TextOut(hDC, 0, 120, tamp, strlen(tamp));
        ReleaseDC(hfen, hDC);   // Rendre le DC !
      } break;
// SI Aucun des quatre cas grs
      default:    /* On rend le contrle */
          return DefWindowProc(hfen, message, wParam, lParam);
    }
  return 0;
}
